'   **********************************************
' 	***	Gravity simulator with Graphics output ***
'	***         By Alex Wade 1987 		       ***
'   *** Based on an idea by W.R.Mansfield '84  ***
'	***        All rights reserved             ***
'	**********************************************

' 	Global Variables Used
'		G	:=gravitational constant (short int)
'		m(2) := Masses of objects  
'		POSIT := 2D array with POSITitions of m(1) and m(2)
'		**************************************************
'		Attraction=mass*g/dist*dist (force in newtons
'		Distance = Attraction/mass
'***************************************************************
defint a-z

LIBRARY "gemvdi","gemaes"




CONST maxprintarray=60
' Defines how large printer$ array will be.
' This is the array which stores data ready for printing
' if you use continuous stationary, this number can be fairly high
' and the data will be printed after the simulation has been running for 
' quite a long time.
' 
'The data is printed when printer$ array is filled up.
' To clear printer$ either use any option from the DEFINE menu
' or use the RESET option.


DIM POSIT!(2,3),disp!(3),oPOSIT!(2,3),veloc!(2,3),m!(2),datarr!(2,6)
DIM flagarr(10),printer$(2,maxprintarray)
  ' dim 3d coords and displacement vector
' FLAGARR is a flag array for things like collisions and special conditions
' DATARR is a record of the origional parameters entered from the menu
'     
CONST mu_mesag=16,mu_button=2,mu_keybd=1
CONST datinterval=10 ' this determines how often the data is printed 
	' when SHOWDATA or PRINTER is activated.1= all data is displayed
	' (this is very slow).10=data is displayed every tenth update.
	
menu$="[ Desk |  About GravSim ][ File | Load \ Save \(------\ Quit ]"
menu$=menu$+"[ Define | Position 1 \ Position 2 \(---------------\ Velocity 1 \ Velocity 2 \(---------------\ Mass 1 \ Mass 2 \(--------------\ Gravity \ Speed \ Title ]"

menu$=menu$+"[ Goodies | Groundline \ Decay \ Collision \ Printer \ Showdata ]" 
menu$=menu$+"[ Operate | Run \ Stop \ Continue \(------\ Reset ]"
' the menu title menus


menu_pointer&=FNmenu&(menu$)

datarr!(1,1)=100: datarr!(2,1)=200 : datarr!(1,6)=10 : datarr!(2,6)=5000

datarr!(1,5)=1 : datarr!(2,5)=1000
constant1!=0: constant2!=0
reset_data

window off
dim mess (7)
 
fullw 2

vst_effects 1


mouse 0
'******************************************
'******************************************
	
	DO
	count=datinterval
	ertp: on error goto errhandle
	poke systab+24,0
	e=FNevnt_multi(MU_MESAG+MU_KEYBD,0,0,0,0,0,0,0,0,0,0,0,0,0,_
					varptr(mess(0)),0,0,0,0,0,k,0)

	
		IF e AND MU_MESAG THEN do_message mess(0)  'there was a message
		IF e AND MU_KEYBD THEN BEEP
		if flagarr(10)=-1 then  call runloop
		
	LOOP
	finished:	stop	-1	' stop without asking for a key
'************************************************
'************************************************

SUB do_message(val mes_type)

	SHARED mess(1),menu_pointer&,flagarr(10)

	STATIC title,item,junk

	 SELECT CASE mes_type
	 CASE  10: ' Menu selected

	
		title=mess(3)

		item=mess(4)
		'print item
		SELECT CASE item
			CASE 10: junk=FNform_alert(1,"[0][ PD Gravity Simulator. | Written by Alex Wade | Copyright 'LEPTON 86'  ][ OK ]") 
			CASE 19 : lddat
			CASE 20 : svdat
		
			CASE 22 : junk=FNform_alert (2,"[2][ WARNING | This will erase | all data from memory ][ OK | CANCEL ]")
					if junk=1 then goto finished
					
			CASE 24 to 35 : datent item
			CASE 37 : beep 
					flagarr (3)=not flagarr(3)' ground
					if flagarr (3)=-1  then call groundline else call groundoff
					
			CASE 38 : beep
					flagarr (4)=not flagarr(4)' decay
			
			CASE 39 : beep
					flagarr (5)=not flagarr(5)' collision		
			CASE 40 : beep
					flagarr (6)=not flagarr(6)' data to printer
					if flagarr (6)=-1 then lprint "Position.                                  Velocity."
			CASE 41 : beep
					flagarr (7)=not flagarr(7) ' data to screen
			
			CASE 43 : flagarr(10)=-1' run
			
			CASE 44 :flagarr(10)=0'stop
			CASE 45 : flagarr(10)=-1 ' continue (same as run)
			CASE 47 : beep 
					junk=FNform_alert (2,"[2][ WARNING | This will reset all data][ OK | CANCEL ]") 
			if junk=1 then call reset_data
			
			CASE ELSE : goto finished' 
		END SELECT
 	if item>=37 and item <=41 then menu_icheck menu_pointer&,item,abs(flagarr(item-34))
	' un-highlight the menu item even if not at front
	menu_tnormal menu_pointer&,title,1
end select

END SUB



sub runloop
	shared posit!(2),disp!(3),g!,oposit!(2),attr!,m!(2),dflag,count,dist!
	shared veloc!(2),speed,flagarr(10)
shared constant1!,constant2!
constant1!=m!(1)*speed
constant2!=m!(2)*speed 
	
'print posit!(1,1);posit!(1,2);"  ";posit!(2,1);posit!(2,2)

do	
locate 1,1
write attr!
write dist!

poke systab+24,1 ' turns off GEM interaction

		calcforce 

		calcdisp 

		update 

poke systab+24,0 ' turns GEM back on again
		plot 

if flagarr(5)=-1 then call check 

if flagarr(4)=-1 then call decay ' orbital decay due to atmospheric friction
							' ,other masses,tides etc..
							' NOTE: here it speeds up with proximity 
							' of masses.
	
		a$=inkey$
		if flagarr(6)=-1 or flagarr(7)=-1 then
		 count=count-1
		if count=0 then 
		count=datinterval
		call printstats
		end if
	end if
	
          
          
          
		     

print mouse (2)	

loop until mouse (2) =1 or inkey$<>"" or flagarr(10)=0
	

end sub

'*******************************************

sub plot
shared posit!(2),oposit!(2)
local t

locate 1,1

                                                                                                                                                                                                                                                      

for t=1  to 2
	if posit!(t,2)>0 and posit!(t,1)>50 and posit!(t,1)<640 and posit!(t,2)<640 then 
		color t,t,t
		linef oposit!(t,1),oposit!(t,2)/3,posit!(t,1),posit!(t,2)/3
		' plot from last position to new position
	end if
next t


for t=1 to 2
	color 1,0,0

next t



	




end sub 
'*******************************************

sub calcforce 
shared g!,attr!,posit!(2),m!(2),dist!

	local x!,y!,junk!

	x!=posit!(1,1)-posit!(2,1)
	x!=x!*x!

	y!=posit!(1,2)-posit!(2,2)
	y!=y!*y!
	junk!=x!+y! 
	dist!=sqr(x!+y!)	' use pythagorus's theorum to find dist
    
	attr!=(m!(1)+m!(2))*G!/(junk!)

end sub

'*******************************************
 
sub calcdisp  
shared posit!(2),disp!(3),m!(2),veloc!(2),speed,attr!,constant1!,constant2!
local x!,y!,time
time=1

	x!=posit!(1,1)-posit!(2,1)

	y!=posit!(1,2)-posit!(2,2)
	veloc!(2,1)=veloc!(2,1)+(attr!)*(x!/constant2!)
	veloc!(2,2)=veloc!(2,2)+(attr!)*(y!/constant2!)
	x!=-x! : y!=-y!

	veloc!(1,1)=veloc!(1,1)+(attr!)*(x!/constant1!)
	veloc!(1,2)=veloc!(1,2)+(attr!)*(y!/constant1!)

end sub

'*******************************************

sub update
shared posit!(2),oposit!(2),disp!(3),m!(2)
shared veloc!(2)
for t=1 to 2
	oposit!(1,t)=posit!(1,t)
	oposit!(2,t)=posit!(2,t)
next t

for t=1 to 2
	posit!(1,t)=posit!(1,t)+veloc!(1,t)
	posit!(2,t)=posit!(2,t)+veloc!(2,t)
	next t
end sub
'*****************************************
sub printstats
	shared veloc!(2),dist!,attr!,m!(2),posit!(2),flagarr(10),printer$(2),printarray
	color 3,3,3 

	
	
	
	locate 16,1
	a$= "POSIT1 "+str$(posit!(1,1))+","+str$(posit!(1,2))+"*** VELOC1 "+str$(veloc!(1,1))+","+str$(veloc!(1,2))+"        "     
	b$= "POSIT2 "+str$(posit!(2,1))+","+str$(posit!(2,2))+"*** VELOC2 "+str$(veloc!(2,1))+","+str$(veloc!(2,2))+"        "  
	if flagarr (7)=-1 then 
					locate 16,1
					
					print a$
					print b$
	end if
	if flagarr (6)=-1 then
					printarray=printarray+1
					printer$(1,printarray)=a$
					printer$(2,printarray)=b$
					if printarray=maxprintarray then
					beep : beep
					locate 16,1
					print "****** PRINTING DATA...ensure printer is on & on-line******"
					for t=1 to maxprintarray
					lprint printer$(1,t)
					lprint printer$(2,t)
					next t
					printarray=0
					locate 16,1
					print "                                                            "
					end if
					
				
				end if
				
color 1,1,1
locate 1,1
end sub
'*************************************************************
sub check
	shared posit!(2),flagarr(10)
	
	local t,q,x(2),y(2) ' ,z(2) ....not needed in 2D model
	for t=1 to 2
		x(t)=int(posit!(t,1))
		y(t)=int(posit!(t,2))
		
	next t 
	if flagarr(3)=-1 and y(1)>450 then flagarr(1)=-2
	if x(1)-5<x(2) and x(1)+5 >x(2)then flagarr(1)=1
	if y(1)-5<y(2) and y(1)+5 >y(2)then flagarr(1)=not flagarr(1)
if flagarr(1)=-2 then
	
	vswr_mode 2
	for q=2 to 1 step-1 
		beep
		color q-1,q-1,q-1,2,12
		for t=1 to 50 step 10
				circle x(1),y(1)/3,t/2	' flashy effect to show explosion
		next t
	next q
	flagarr(1)=0
	flagarr(10)=0
	vswr_mode 1
	end if
end sub
'*****************************************************************
sub decay
	shared veloc!(2),dist!,m!(2)
	local decon
	' this governs how quickly the orbit decays
	decon!=1.5
	for t=1 to 2
		for q=1 to 3
			veloc!(t,q)=veloc!(t,q)-(veloc!(t,q)/m!(t)/(dist!^decon!))
		next q
	next t
	
end sub
'****************************************************************
sub lddat

shared datarr!(2),flagarr(10),title$,menu_pointer&
openw 1
window locate 1,50,100,540,90
window output 1
on error goto filerr

print "    LOAD DATA"
print " Input name of file.."
input " (exclude .GSD suffix)";file$
if len (file$)>32 then file$= mid$(file$,0,8)
open "I",#1,file$+".GSD",128
input# 1,id$
print id$
if id$<>"AW87" then print "FILE NOT FOUND....Sorry.": goto ldend
 input# 1,title$

for t=1 to 2
	for x=1 to 6
		input# 1,datarr!(t,x)
	print datarr!(t,x)
	next x
next t
for t=1 to 10
	input# 1,flagarr(t)
next t
close #1
call reset_data 

ldend: 

window output 2
clearw 1
fullw 1
closew 1
clearw 2
for t=1 to 5
	menu_icheck menu_pointer&,t+36,abs(flagarr(t+2))
 next t
if flagarr (3)=-1 then call groundline 
end sub
'****************************************************
sub svdat
static x%,a$,t%,file$
shared datarr!(2),flagarr(10),title$
openw 1
window locate 1,50,100,540,90
window output 1
on error goto filerr
print "   SAVE DATA "
ent:print " Enter filename (sorry, no DIR available)"
input " exclude .GSD suffix.";file$
if len (file$)>90 then 
	print "! Too long..[Q] uit or [R] e-try"
	do
	a$=inkey$
	a$=ucase$(a$)
	loop until a$="Q" or a$="R"
	if a$="R" then goto ent else goto svend
end if
open "O",#1,file$+".GSD",128
print# 1,"AW87"
print# 1,title$
for t=1 to 2
for x=1 to 6
	print# 1,datarr!(t,x)
 	print datarr!(t,x)
next x
next t

for t=1 to 10
	print# 1,flagarr(t)
next t
close #1


svend:
 

window output 2
clearw 1
fullw 1
closew 1
clearw 2
end sub

'**********************************************************

sub datent( item)
shared posit!(2),m!(2),veloc!(2),g!,speed,title$,datarr!(2)
reset
openw 1
window locate 1,50,100,540,90
window output 1

select case item
	case 24
		print "POSITION Body 1";posit!(1,1);",";posit!(1,2)
		input "Enter X position of mass 1";a$
		if a$<>"*" then
		
		posit!(1,1)=val(a$)

		input "Enter Y position of mass 1";a$
	
		
		posit!(1,2)=val (a$)
		end if
	case 25
		
		print "POSITION Body 2";posit!(2,1);",";posit!(2,2)
		input "Enter X position of mass 2";a$
		if a$<>"*" then
		posit! (2,1)=val (a$)
		
		input "Enter Y position of mass 2";a$
		
		posit! (2,2)=val (a$)
	end if
	case 27 
		print "VELOCITY Body 1";veloc!(1,1);",";veloc!(1,2)
		input "Enter X velocity of mass 1";a$
		if a$<>"*" then
		veloc!(1,1)=val (a$)
	
		input "Enter Y velocity of mass 1";a$
		
		veloc!(1,2)=val (a$)
	end if
	case 28
		print "VELOCITY Mass 2..";veloc!(2,1);",";veloc!(2,2)
		input "Enter X velocity of mass 2";a$
		veloc!(2,1)=val (a$)
		
		input "Enter Y velocity of mass 2";a$
		veloc!(2,2)=val (a$)
		
	case 30
		Print "MASS Body 1=";m!(1)
		input "Enter Mass of body 1";a$
		m!(1)=val (a$)
		
	case 31 
		Print "MASS Body 2=";m!(2)
		input "Enter Mass of body 2";a$
		m!(2)=val (a$)
		
	case 33
		PRINT "GRAVITATIONAL CONSTANT=";g!
		input "Enter G";g!
		
	Case 34
		PRINT "SPEED / PRECISION=";speed
		input "Enter SPEED";speed
		
	case 35
		PRINT "TITLE "
		print title$
		Print "Enter new title.."
		input a$
		if a$<>"*" then title$=a$	
	
	case else
	beep 
	end select
	call datstore
		
window output 2
openw 2
closew 1
end sub	
'*********************************************************
sub reset_data

' this resets all variables to the original values held in datarr!
shared datarr!(2),veloc!(2),posit!(2),flagarr(10),m!(2),G!,Speed,title$
shared printarray
printarray=0

for t=1 to 2
	for x=1 to 2
		posit!(t,x)=datarr!(t,x)
		veloc!(t,x)=datarr!(t,x+2)
	next x
	m!(t)=datarr!(t,5)

next t
'for t=1 to 9
	'flagarr(t)=0
'next t
speed=datarr!(2,6)
G!=datarr!(1,6)

end sub 
'**************************************************
 
sub datstore
shared datarr!(2),veloc!(2),posit!(2),m!(2),g!,speed
static t,x
for t=1 to 2
	for x=1 to 2
	datarr!(t,x)=posit!(t,x)
	datarr!(t,x+2)=veloc!(t,x)
	next x
next t
for t=1 to 2
	datarr!(t,5)=m!(t)
next t
datarr!(1,6)=g!
datarr!(2,6)=speed
beep
end sub
'**********************************************************
sub groundline 
beep
shared flagarr (10)
static lx,ly,x,y,t
color 1,1,1,1,1
ox=0:oy=150
for t=1 to 640 step 10
 y=150+(2*rnd(1)-1)
 linef ox,oy,t,y
 ox=t
 oy=y
 next t
flagarr(5)=-1
fill 100,155
end sub
'***********************************************************
sub groundoff
static x,y
color 1,1,1,1,1
linef 0,148,640,148
color 0,0,0,0,0
fill 100,155
linef 0,148,640,148
color 1,1,1,1,1
end sub

' ************************************
' ***** Error handling routines   ****
' ************************************

filerr: 
if erl>372 and erl <400 then sub$="SAVE" else sub$="LOAD"
x=err
select case x
case 99: Print "*** BREAK PRESSED ***"
	if sub$="SAVE" then resume svend else resume ldend
case 53: print "*** File not found"
	
case 61: print "*** Disk Full"
	
case 52 : print "*** Filename invalid"
case 57 : print "*** Disk I/O error..."
case else : print "*** Misc. error !..."
		
end select		

do loop until inkey$<>"" 
if sub$="SAVE" then resume svend else resume ldend
errhandle:
	x=err
	
	
	select case x
	
	case 6: print "*** Number too large"
	case 11: print "*** Division by zero (no zero masses or gravity allowed)"
	for t=1 to 2
	print "Mass ";t;"="; m!(t)
	next t
	print "Gravity=";g!
	
	
	case 31: print "*** Argument out of range."
	case else : print "*** ERROR"
	end select
	print "Simulation halted."
	print "Error occured at line ";erl
	print "Resetting flags"
	for t=1 to 10
	flagarr (t)=0
	next t
	for t=1 to 5
	menu_icheck menu_pointer&,t+36,0
	next t
	print "Press any key...."
	
	do loop until inkey$<>""
	beep
	
	fullw 2
	clearw 2
	
	
	resume ertp 
	
		 